SystemOrganization addCategory: #'tODE-Metacello'!

TOView subclass: #TOMetacelloPackageClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOMetacelloPackageClass methodsFor: 'rendering' stamp: 'dkh 6/10/2011 21:34'!
renderContentOn: html main: main
	| order classes indents displayString classList extensionClassList |
	order := SortedCollection
		sortBlock: [ :assoc1 :assoc2 | 
			| result chain1 chain2 max i |
			result := nil.
			chain1 := assoc1 key.
			chain2 := assoc2 key.
			max := chain1 size min: chain2 size.
			i := 1.
			[ result isNil and: [ i <= max ] ]
				whileTrue: [ 
					(chain1 at: i) = (chain2 at: i)
						ifTrue: [ i := i + 1 ]
						ifFalse: [ result := (chain1 at: i) name < (chain2 at: i) name ] ].
			result isNil
				ifTrue: [ chain1 size < chain2 size ]
				ifFalse: [ result ] ].
	classList := (self frame rendererForCenterTab: #metacello) classList.
	extensionClassList := (self frame rendererForCenterTab: #metacello) extensionClassList.
	classList
		do: [ :cl | extensionClassList removeKey: cl ifAbsent: []].
	classes :=  classList, extensionClassList keys.
	classes
		do: [ :cl | 
			| supersChain |
			supersChain := cl withAllSuperclasses reversed.
			supersChain removeAllSuchThat: [ :class | (classes includes: class) not ].
			order add: supersChain contents -> cl ].
	indents := IdentityDictionary new.
	order do: [ :assoc | indents at: assoc value put: assoc key size - 1 ].
	classes := classes asArray sorted: [ :a :b | a name <= b name ].
	order
		do: [ :assoc | 
			| cl |
			cl := assoc value.
			(indents at: cl) * 2 timesRepeat: [ html space ].
			self
				renderLink: [ :s | 
					self currentSession push: cl selecting: #classBrowser.
					main updateCenterSideHistory: s ]
				with: [ 
					(extensionClassList includesKey: cl)
								ifTrue: [html text: cl name asString]
								ifFalse: [html strong: cl name asString].
					html break ]
				on: html ]! !

TOView subclass: #TOMetacelloView
	instanceVariableNames: 'selectedPathElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOMetacelloView subclass: #TOMetacello
	instanceVariableNames: 'workingCopy configurationInfo packageInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOMetacello methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:04'!
classList
	self selectedPathElement == #class
		ifTrue: [ ^ {(self actualClass)} ].
	self selectedPathElement == #package
		ifTrue: [ ^ self workingCopy packageInfo classes ].
	self selectedPathElement == #configuration
		ifTrue: [ ^ self configurationInfo currentVersion currentlyLoadedClassesInVersion ].
	^ #()! !

!TOMetacello methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:04'!
configurationInfo
	configurationInfo
		ifNil: [ 
			self currentSystem configurationRoot configurations
				do: [ :config | 
					config packages
						do: [ :pkg | 
							pkg basePackageName = self workingCopy packageName
								ifTrue: [ 
									configurationInfo := config.
									packageInfo := pkg.
									^ config ] ] ] ].
	^ configurationInfo! !

!TOMetacello methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:27'!
defaultPathElement

	^#class! !

!TOMetacello methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:05'!
extensionClassList
	self selectedPathElement == #class
		ifTrue: [ | classes |
			classes := Dictionary new.
			(self currentSystem classHierarchyFor: self actualClass) do: [:cl | classes at: cl put: #() ]. 
			^classes].
	self selectedPathElement == #package
		ifTrue: [ 
			| classes wc |
			classes := Dictionary new.
			wc := self workingCopy.
			wc packageInfo extensionClasses do: [ :cl | classes at: cl put: (wc packageInfo extensionCategoriesForClass: cl) ].
			^ classes ].
	self selectedPathElement == #configuration
		ifTrue: [ ^ self configurationInfo currentVersion currentlyLoadedExtensionClassesInVersion ].
	^ Dictionary new! !

!TOMetacello methodsFor: 'testing' stamp: 'dkh 6/11/2011 09:23'!
hasClassInfo

	^true! !

!TOMetacello methodsFor: 'testing' stamp: 'dkh 6/11/2011 09:23'!
hasPackageInfo

	^true! !

!TOMetacello methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:04'!
packageInfo
	packageInfo ifNil: [ self configurationInfo ].
	^ packageInfo! !

!TOMetacello methodsFor: 'rendering' stamp: 'dkh 6/10/2011 20:30'!
renderContentOn: html main: main
	self renderPathContentOn: html main: main.
	html break; break.
	self renderTableContentOn: html main: main
! !

!TOMetacello methodsFor: 'accessing' stamp: 'dkh 6/10/2011 17:49'!
workingCopy
	workingCopy
		ifNil: [ 
			MCWorkingCopy
				managersForClass: self actualClass
				do: [ :wc | 
					workingCopy := wc.
					^ wc ] ].
	^ workingCopy! !

TOMetacelloView subclass: #TOMetacelloConfigurationInfo
	instanceVariableNames: 'configurationInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOMetacelloConfigurationInfo methodsFor: 'accessing' stamp: 'dkh 6/10/2011 22:08'!
classList
	^ self configurationInfo currentVersion currentlyLoadedClassesInVersion! !

!TOMetacelloConfigurationInfo methodsFor: 'accessing' stamp: 'dkh 6/10/2011 22:03'!
configurationInfo
	^ configurationInfo! !

!TOMetacelloConfigurationInfo methodsFor: 'accessing' stamp: 'dkh 6/10/2011 22:03'!
configurationInfo: anObject
	configurationInfo := anObject! !

!TOMetacelloConfigurationInfo methodsFor: 'accessing' stamp: 'dkh 6/10/2011 22:08'!
extensionClassList
	^ self configurationInfo currentVersion currentlyLoadedExtensionClassesInVersion! !

!TOMetacelloConfigurationInfo methodsFor: 'rendering' stamp: 'dkh 6/11/2011 09:42'!
renderContentOn: html for: aTOInspector main: main
	self renderPathContentOn: html main: main.
	html
		break;
		break.
	self configurationInfo ifNil: [ html text: '???' ] ifNotNil: [ self configurationInfo renderLabelOn: html main: main ].
	html horizontalRule.
	self configurationInfo renderCommandsOn: html for: aTOInspector main: main! !

!TOMetacelloConfigurationInfo methodsFor: 'rendering' stamp: 'dkh 6/11/2011 09:52'!
renderInspectorContentOn: html for: aTOInspector main: main
	aTOInspector getMembers.
	aTOInspector basicInspect
		ifTrue: [ ^ aTOInspector renderStandardContentOn: html main: main ].
	self renderContentOn: html for: aTOInspector main: main.
	html horizontalRule.
	aTOInspector renderBasicToggleOn: html main: main.
! !

!TOMetacelloConfigurationInfo methodsFor: 'accessing' stamp: 'dkh 6/10/2011 22:10'!
tODEInspectorFields
	<tODEInspectorFields>
	"force inspector to have standard and basic views"
	^self tODEBasicInspectorFields! !

!TOMetacelloConfigurationInfo methodsFor: 'accessing' stamp: 'dkh 6/10/2011 22:05'!
workingCopy

	^self configurationInfo workingCopy  ! !

TOMetacelloConfigurationInfo subclass: #TOMetacelloPackageInfo
	instanceVariableNames: 'packageInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOMetacelloPackageInfo methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:17'!
classList
	
	^ super classList, self workingCopy packageInfo classes! !

!TOMetacelloPackageInfo methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:27'!
defaultPathElement

	^#package! !

!TOMetacelloPackageInfo methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:17'!
extensionClassList
	| classes wc |
	classes := super extensionClassList.
	wc := self workingCopy.
	wc packageInfo extensionClasses do: [ :cl | classes at: cl put: (wc packageInfo extensionCategoriesForClass: cl) ].
	^ classes! !

!TOMetacelloPackageInfo methodsFor: 'testing' stamp: 'dkh 6/11/2011 09:23'!
hasPackageInfo

	^true! !

!TOMetacelloPackageInfo methodsFor: 'accessing' stamp: 'dkh 6/10/2011 22:03'!
packageInfo
	^ packageInfo! !

!TOMetacelloPackageInfo methodsFor: 'accessing' stamp: 'dkh 6/10/2011 22:03'!
packageInfo: anObject
	packageInfo := anObject! !

!TOMetacelloPackageInfo methodsFor: 'rendering' stamp: 'dkh 6/11/2011 09:37'!
renderContentOn: html for: aTOInspector main: main
	self renderPathContentOn: html main: main.
	html break; break.
	self renderTableContentOn: html main: main.
	html horizontalRule.
	self packageInfo renderCommandsOn: html for: aTOInspector main: main.! !

!TOMetacelloPackageInfo methodsFor: 'rendering' stamp: 'dkh 6/11/2011 09:43'!
renderPackageInfoLinkOn: html main: main
	self packageInfo ifNil: [ html text: '???' ] ifNotNil: [ self packageInfo renderLabelOn: html main: main ]! !

!TOMetacelloPackageInfo methodsFor: 'accessing' stamp: 'dkh 6/10/2011 22:05'!
workingCopy

	^self packageInfo workingCopy  ! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 6/10/2011 22:01'!
actualClass

	self object isBehavior
		ifTrue: [ ^self object ].
	^super actualClass! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:03'!
classList

	^#()! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:07'!
configurationInfo

	self subclassResponsibiilty   ! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:27'!
defaultPathElement

	^#configuration! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:17'!
extensionClassList

	^Dictionary new! !

!TOMetacelloView methodsFor: 'testing' stamp: 'dkh 6/11/2011 09:23'!
hasClassInfo

	^false! !

!TOMetacelloView methodsFor: 'testing' stamp: 'dkh 6/11/2011 09:23'!
hasPackageInfo

	^false! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:07'!
packageInfo

	self subclassResponsibiilty   ! !

!TOMetacelloView methodsFor: 'rendering' stamp: 'dkh 6/11/2011 09:41'!
renderConfigurationInfoLinkOn: html main: main
	self
		renderLink: [ :s | 
			| ci fr |
			ci := (TOMetacelloConfigurationInfo new)
				object: self object;
				configurationInfo: self configurationInfo;
				yourself.
			fr := self currentSession findFrameFor: ci.
			ci frame: fr.
			self currentSession push: ci selecting: #inspect.
			main updateCenterSideHistory: s ]
		with: [ self configurationInfo ifNil: [ html text: '???' ] ifNotNil: [ self configurationInfo renderLabelOn: html main: main ] ]
		on: html! !

!TOMetacelloView methodsFor: 'rendering' stamp: 'dkh 6/11/2011 09:41'!
renderPackageInfoLinkOn: html main: main
	self
		renderLink: [ :s | 
			| pi fr |
			pi := (TOMetacelloPackageInfo new)
				object: self object;
				configurationInfo: self configurationInfo;
				packageInfo: self packageInfo;
				yourself.
			fr := self currentSession findFrameFor: pi.
			pi frame: fr.
			self currentSession push: pi selecting: #inspect.
			main updateCenterSideHistory: s ]
		with: [ self packageInfo ifNil: [ html text: '???' ] ifNotNil: [ self packageInfo renderLabelOn: html main: main ] ]
		on: html! !

!TOMetacelloView methodsFor: 'rendering' stamp: 'dkh 6/11/2011 09:44'!
renderPathContentOn: html main: main
	| aClass |
	html text: 'Package content: '.
	self configurationInfo
		ifNil: [ html text: '???' ]
		ifNotNil: [ 
			self selectedPathElement == #configuration
				ifTrue: [ html strong: 'configuration classes' ]
				ifFalse: [ 
					self
						renderLink: [ :s | 
							selectedPathElement := #configuration.
							main updateCenterSideHistory: s ]
						with: [ html text: 'configuration classes' ]
						on: html ] ].
	self hasPackageInfo
		ifTrue: [ 
			html text: '->'.
			self packageInfo
				ifNil: [ html text: '???' ]
				ifNotNil: [ 
					self selectedPathElement == #package
						ifTrue: [ html strong: 'package classes' ]
						ifFalse: [ 
							self
								renderLink: [ :s | 
									selectedPathElement := #package.
									main updateCenterSideHistory: s ]
								with: [ html text: 'package classes' ]
								on: html ] ] ].
	self hasClassInfo
		ifTrue: [ 
			html text: '->'.
			self selectedPathElement == #class
				ifTrue: [ html strong: self actualClass name ]
				ifFalse: [ 
					self
						renderLink: [ :s | 
							selectedPathElement := #class.
							main updateCenterSideHistory: s ]
						with: [ html text: self actualClass name ]
						on: html ] ]! !

!TOMetacelloView methodsFor: 'rendering' stamp: 'dkh 6/11/2011 09:15'!
renderTableContentOn: html main: main
	html
		table: [ 
			html
				tableRow: [ 
					html tableData: [ html text: 'Package: ' ].
					html tableData: [ self renderPackageInfoLinkOn: html main: main ] ].
			html
				tableRow: [ 
					html tableData: [ html text: 'Configuration: ' ].
					html tableData: [ self renderConfigurationInfoLinkOn: html main: main ] ] ]! !

!TOMetacelloView methodsFor: 'accessing' stamp: 'dkh 6/11/2011 09:27'!
selectedPathElement

	selectedPathElement ifNil: [ selectedPathElement := self defaultPathElement ].
	^selectedPathElement! !

!MBCommand class methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 12:55'!
istODECommand

	^false! !

!MBCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 17:39'!
renderCommandOn: html for: aTOInspector main: main
	aTOInspector
		renderButton: [ :s | 
			self execute.
			main updateCenterSideHistory: s ]
		label: self todeTitle
		on: html! !

!MBCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 17:39'!
todeTitle

	^self title! !

!TOSystem methodsFor: '*tode-metacello' stamp: 'dkh 6/3/2011 16:06'!
configurationRoot

	^MBConfigurationRoot current! !

!MBRevertPackageCommand class methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 12:55'!
istODECommand

	^true! !

!MBRevertPackageCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 17:40'!
renderCommandOn: html for: aTOInspector main: main
	| selectedName ancestors ancestorNames id ajax |
	ancestors := target workingCopy ancestry breadthFirstAncestors.
	ancestorNames := ancestors collect: [ :ea | ea name ].
	selectedName := ancestorNames first.
	(html select)
		id: (id := html nextId);
		list: ancestorNames;
		selected: selectedName;
		onChange: (html jQuery ajax callback: [ :value | selectedName := value ] value: (html jQuery id: id) value).
	ajax := html jQuery ajax.
	target workingCopy modified
		ifTrue: [ 
			ajax
				confirm:
					'You are about to load a new version of ' , target basePackageName printString
						, ' that has unsaved changes in the image.  If you continue, you will lose these changes?' ].
	ajax
		script: [ :s | 
			self
				revertPackage: (ancestors at: (ancestorNames indexOf: selectedName))
				for: aTOInspector
				script: s
				main: main ].
	(html submitButton)
		onClick: ajax;
		with: self todeTitle! !

!MBRevertPackageCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 17:15'!
revertPackage: info for: aTOInspector script: s main: main
	"unconditional loading by the time this method is called ... overrides modified packages."

	[ 
	(target workingCopy repositoryGroup versionWithInfo: info ifNone: [ ^ s alert: 'No repository found for ' , info name ])
		load ] on: Warning do: [ :ex | ex resume: true ].
	s alert: 'Reverted: ' , info name.
	main updateCenterSideHistory: s! !

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 11:17'!
renderLabelOn: html main: main
	| string wc loadedPkgName cssSpanClass |
	string := super buildStringOrText.
	(wc := self workingCopy) isNil
		ifTrue: [ ^ string ].
	cssSpanClass := ''.
	wc ancestry ancestors notEmpty
		ifTrue: [ 
			loadedPkgName := wc ancestry ancestors first name.
			loadedPkgName = self name
				ifFalse: [ 
					(self compareWorkingCopyNamed: loadedPkgName using: #<=)
						ifTrue: [ cssSpanClass := 'outofspec ' ].
					cssSpanClass := cssSpanClass , 'mismatch ' ] ].
	self isDirty
		ifTrue: [ cssSpanClass := cssSpanClass , 'dirty ' ].
	cssSpanClass isEmpty
		ifTrue: [ ^ html text: string ].
	^ (html span)
		class: cssSpanClass;
		with: string! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/11/2011 09:39'!
renderCommandsOn: html for: aTOInspector main: main
	| commands |
	commands := ((self commands select: [ :each | each istODECommand ])
		collect: [ :commandClass | commandClass target: self for: nil ]) asArray sort: [ :a :b | a order <= b order ].
	commands isEmpty
		ifTrue: [ ^ self ].
	html horizontalRule.
	commands do: [ :command | 
		command renderCommandOn: html for: aTOInspector main: main.
		html space ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 11:21'!
renderLabelOn: html main: main

	html text: self printString! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 11:19'!
renderLabelOn: html main: main
	| string cv specVersion wc cssSpanClass |
	[ string := super buildStringOrText ]
		on: Error
		do: [ :ex | 
			^ (html span)
				class: 'error';
				with: string ].
	cssSpanClass := ''.
	((wc := self workingCopy) notNil and: [ wc needsSaving ])
		ifTrue: [ cssSpanClass := 'dirty ' ].
	self currentVersion.	"prime the pump"
	currentVersion == #notLoaded
		ifTrue: [ 
			cssSpanClass isEmpty
				ifTrue: [ html text: string ].
			^ (html span)
				class: cssSpanClass;
				with: string ].
	super isDirty | self currentVersionMismatch
		ifTrue: [ cssSpanClass := 'mismatch ', cssSpanClass ].
	self currentVersion versionStatus == #somethingLoaded
		ifTrue: [ cssSpanClass := cssSpanClass , 'somethingloaded ' ].
	cssSpanClass isEmpty
		ifTrue: [ ^ html text: string ].
	^ (html span)
		class: cssSpanClass;
		with: string! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 21:02'!
renderMetacelloSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/3/2011 17:06'!
renderMetacelloTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 21:01'!
tODEMetacelloSidebarSpec

	^ {(TOTabSpec new)
		id: #packageClasses;
		rendererClass: TOMetacelloPackageClass;
		receiver: self;
		label: 'package classes';
		order: 50;
		group: 'development';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:}! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 20:37'!
tODEMetacelloTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #metacello;
		rendererClass: TOMetacello;
		receiver: self;
		label: 'metacello';
		order: 70;
		group: 'development';
		sidebarSpec: self tODEMetacelloSidebarSpec;
		renderSelector: #renderMetacelloTabOn:spec:tOdeMain:! !
